import 'package:gherkin/gherkin.dart';
import 'package:gherkin_dsl/gherkin_dsl.dart';

import 'common.dart';

class GenericGiven<TWorld extends World> extends GivenWithWorld<TWorld>{
  String _pattern;
  Zero<TWorld> _step;


  GenericGiven(this._pattern, this._step);

  @override
  Future<void> executeStep() async {
    await _step(this);
  }

  @override
  RegExp get pattern => RegExp(_pattern);
}
GenericGiven<TWorld> given<TWorld extends World>(String pattern,Zero<TWorld> step){
  return GenericGiven<TWorld>(pattern,step);
}

