library gherkindsl;
import 'package:gherkin/gherkin.dart';
import 'package:gherkin_dsl/gherkin_dsl.dart';

import 'common.dart';

class GenericWhen<TWorld extends World> extends WhenWithWorld<TWorld>{
  String _pattern;
  Zero<TWorld> _step;


  GenericWhen(this._pattern, this._step);

  @override
  Future<void> executeStep() async {
    await _step(this);
  }

  @override
  RegExp get pattern => RegExp(_pattern);
}
GenericWhen<TWorld> when<TWorld extends World>(String pattern,Zero<TWorld> step){
  return GenericWhen<TWorld>(pattern,step);
}

class GenericWhen1<TWorld extends World,Input1> extends When1WithWorld<Input1,TWorld>{
  String _pattern;
  One<TWorld,Input1> _step;


  GenericWhen1(this._pattern, this._step);

  @override
  Future<void> executeStep(Input1 first) async {
    await _step(this,first);
  }

  @override
  RegExp get pattern => RegExp(_pattern);
}
GenericWhen1<TWorld,Input1> when1<TWorld extends World,Input1>(String pattern,One<TWorld,Input1> step){
  return GenericWhen1<TWorld,Input1>(pattern,step);
}

